Index: /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_bdy_generic.h90
===================================================================
--- /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_bdy_generic.h90	(revision 9011)
+++ /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_bdy_generic.h90	(revision 9012)
@@ -1,26 +1,2 @@
-#if defined MULTI
-#   define NAT_IN(k)                cd_nat(k)   
-#   define SGN_IN(k)                psgn(k)
-#   define IBD_IN(k)                kb_bdy(k)
-#   define F_SIZE(ptab)             kfld
-#   if defined DIM_2d
-#      define ARRAY_TYPE(i,j,k,l,f)    TYPE(PTR_2D)                , INTENT(inout) ::   ptab(f)
-#      define ARRAY_IN(i,j,k,l,f)      ptab(f)%pt2d(i,j)
-#      define K_SIZE(ptab)             1
-#      define L_SIZE(ptab)             1
-#   endif
-#   if defined DIM_3d
-#      define ARRAY_TYPE(i,j,k,l,f)    TYPE(PTR_3D)                , INTENT(inout) ::   ptab(f)
-#      define ARRAY_IN(i,j,k,l,f)      ptab(f)%pt3d(i,j,k)
-#      define K_SIZE(ptab)             SIZE(ptab(1)%pt3d,3)
-#      define L_SIZE(ptab)             1
-#   endif
-#   if defined DIM_4d
-#      define ARRAY_TYPE(i,j,k,l,f)    TYPE(PTR_4D)                , INTENT(inout) ::   ptab(f)
-#      define ARRAY_IN(i,j,k,l,f)      ptab(f)%pt4d(i,j,k,l)
-#      define K_SIZE(ptab)             SIZE(ptab(1)%pt4d,3)
-#      define L_SIZE(ptab)             SIZE(ptab(1)%pt4d,4)
-#   endif
-#else
 #   define ARRAY_TYPE(i,j,k,l,f)    REAL(wp)                    , INTENT(inout) ::   ARRAY_IN(i,j,k,l,f)
 #   define NAT_IN(k)                cd_nat
@@ -28,4 +4,5 @@
 #   define IBD_IN(k)                kb_bdy
 #   define F_SIZE(ptab)             1
+#   define OPT_K(k)                 
 #   if defined DIM_2d
 #      define ARRAY_IN(i,j,k,l,f)   ptab(i,j)
@@ -43,12 +20,6 @@
 #      define L_SIZE(ptab)          SIZE(ptab,4)
 #   endif
-#endif
-
-#if defined MULTI
-   SUBROUTINE ROUTINE_BDY( ptab, cd_nat, psgn, kfld, kb_bdy )
-      INTEGER                     , INTENT(in   ) ::   kfld        ! number of pt3d arrays
-#else
+
    SUBROUTINE ROUTINE_BDY( ptab, cd_nat, psgn      , kb_bdy )
-#endif
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_bdy_3d  ***
@@ -91,6 +62,6 @@
       ipf = F_SIZE(ptab)   ! 5th    -      use in "multi" case (array of pointers)
       !      
-      ALLOCATE( zt3ns(jpi,jprecj,ipk,ipl,ipf,2), zt3sn(jpi,jprecj,ipk,ipl,ipf,2),   &
-         &      zt3ew(jpj,jpreci,ipk,ipl,ipf,2), zt3we(jpj,jpreci,ipk,ipl,ipf,2)  )
+      ALLOCATE( zt3ns(jpi,nn_hls,ipk,ipl,ipf,2), zt3sn(jpi,nn_hls,ipk,ipl,ipf,2),   &
+         &      zt3ew(jpj,nn_hls,ipk,ipl,ipf,2), zt3we(jpj,nn_hls,ipk,ipl,ipf,2)  )
 
       zland = 0._wp
@@ -109,19 +80,19 @@
                ARRAY_IN(jpi,:,:,:,jf) = ARRAY_IN(  2  ,:,:,:,jf)
             ELSE                                   !* Closed
-               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(     1       :jpreci,:,:,:,jf) = zland  ! east except F-point
-                                               ARRAY_IN(nlci-jpreci+1:jpi   ,:,:,:,jf) = zland  ! west
+               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(     1       :nn_hls,:,:,:,jf) = zland  ! east except F-point
+                                               ARRAY_IN(nlci-nn_hls+1:jpi   ,:,:,:,jf) = zland  ! west
             ENDIF
          ELSEIF(nbondi == -1) THEN              ! subdomain to the east only
-            IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(1:jpreci,:,:,:,jf) = zland     ! south except F-point
+            IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(1:nn_hls,:,:,:,jf) = zland     ! south except F-point
             !
          ELSEIF(nbondi == 1) THEN               ! subdomain to the west only
-            ARRAY_IN(nlci-jpreci+1:jpi,:,:,:,jf) = zland    ! north
+            ARRAY_IN(nlci-nn_hls+1:jpi,:,:,:,jf) = zland    ! north
          ENDIF
          !                                ! North-South boundaries
          !
          IF (nbondj == 2 .OR. nbondj == -1) THEN      !* closed
-           IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(:,1:jprecj,:,:,jf) = zland            ! south except F-point
+           IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(:,1:nn_hls,:,:,jf) = zland            ! south except F-point
          ELSEIF (nbondj == 2 .OR. nbondj == 1) THEN
-                                           ARRAY_IN(:,nlcj-jprecj+1:jpj,:,:,jf) = zland   ! north
+                                           ARRAY_IN(:,nlcj-nn_hls+1:jpj,:,:,jf) = zland   ! north
          ENDIF
       END DO
@@ -138,6 +109,6 @@
                DO jl = 1, ipl
                   DO jk = 1, ipk
-                     DO jh = 1, jpreci
-                        zt3ew(:,jh,jk,jl,jf,1) = ARRAY_IN(jpreci+jh,:,jk,jl,jf)
+                     DO jh = 1, nn_hls
+                        zt3ew(:,jh,jk,jl,jf,1) = ARRAY_IN(nn_hls+jh,:,jk,jl,jf)
                         zt3we(:,jh,jk,jl,jf,1) = ARRAY_IN(iihom +jh,:,jk,jl,jf)
                      END DO
@@ -147,6 +118,6 @@
          !
          !                           ! Migrations
-!!gm      imigr = jpreci * jpj * ipk * ipl * ipf
-         imigr = jpreci * jpj * ipk * ipl
+!!gm      imigr = nn_hls * jpj * ipk * ipl * ipf
+         imigr = nn_hls * jpj * ipk * ipl
          !
          SELECT CASE ( nbondi_bdy(IBD_IN(jf)) )
@@ -169,5 +140,5 @@
          !
          !                           ! Write Dirichlet lateral conditions
-         iihom = nlci-jpreci
+         iihom = nlci-nn_hls
          !
          !
@@ -176,5 +147,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(iihom+jh,:,jk,jl,jf) = zt3ew(:,jh,jk,jl,jf,2)
                   END DO
@@ -184,5 +155,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(jh      ,:,jk,jl,jf) = zt3we(:,jh,jk,jl,jf,2)
                      ARRAY_IN(iihom+jh,:,jk,jl,jf) = zt3ew(:,jh,jk,jl,jf,2)
@@ -193,5 +164,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(jh      ,:,jk,jl,jf) = zt3we(:,jh,jk,jl,jf,2)
                   END DO
@@ -211,7 +182,7 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      zt3sn(:,jh,jk,jl,jf,1) = ARRAY_IN(:,ijhom +jh,jk,jl,jf)
-                     zt3ns(:,jh,jk,jl,jf,1) = ARRAY_IN(:,jprecj+jh,jk,jl,jf)
+                     zt3ns(:,jh,jk,jl,jf,1) = ARRAY_IN(:,nn_hls+jh,jk,jl,jf)
                   END DO
                END DO
@@ -220,6 +191,6 @@
          !
          !                           ! Migrations
-!!gm      imigr = jprecj * jpi * ipk * ipl * ipf
-         imigr = jprecj * jpi * ipk * ipl
+!!gm      imigr = nn_hls * jpi * ipk * ipl * ipf
+         imigr = nn_hls * jpi * ipk * ipl
          !
          SELECT CASE ( nbondj_bdy(IBD_IN(jf)) )
@@ -242,5 +213,5 @@
          !
          !                           ! Write Dirichlet lateral conditions
-         ijhom = nlcj-jprecj
+         ijhom = nlcj-nn_hls
          !
          SELECT CASE ( nbondj_bdy_b(IBD_IN(jf)) )
@@ -248,5 +219,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,ijhom+jh,jk,jl,jf) = zt3ns(:,jh,jk,jl,jf,2)
                   END DO
@@ -256,5 +227,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,      jh,jk,jl,jf) = zt3sn(:,jh,jk,jl,jf,2)
                      ARRAY_IN(:,ijhom+jh,jk,jl,jf) = zt3ns(:,jh,jk,jl,jf,2)
@@ -265,5 +236,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,jh,jk,jl,jf) = zt3sn(:,jh,jk,jl,jf,2)
                   END DO
@@ -279,6 +250,6 @@
          !
          SELECT CASE ( jpni )
-         CASE ( 1 )     ;   CALL lbc_nfd( ptab, NAT_IN(:), SGN_IN(:) )   ! only 1 northern proc, no mpp
-         CASE DEFAULT   ;   CALL mpp_nfd( ptab, NAT_IN(:), SGN_IN(:) )   ! for all northern procs.
+         CASE ( 1 )     ;   CALL lbc_nfd( ptab, NAT_IN(:), SGN_IN(:) OPT_K(:) )   ! only 1 northern proc, no mpp
+         CASE DEFAULT   ;   CALL mpp_nfd( ptab, NAT_IN(:), SGN_IN(:) OPT_K(:) )   ! for all northern procs.
          END SELECT
          !
@@ -297,2 +268,3 @@
 #undef L_SIZE
 #undef F_SIZE
+#undef OPT_K
Index: /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_lnk_generic.h90
===================================================================
--- /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_lnk_generic.h90	(revision 9011)
+++ /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_lnk_generic.h90	(revision 9012)
@@ -72,6 +72,6 @@
       ipf = F_SIZE(ptab)   ! 5th    -      use in "multi" case (array of pointers)
       !
-      ALLOCATE( zt3ns(jpi,jprecj,ipk,ipl,ipf,2), zt3sn(jpi,jprecj,ipk,ipl,ipf,2),   &
-         &      zt3ew(jpj,jpreci,ipk,ipl,ipf,2), zt3we(jpj,jpreci,ipk,ipl,ipf,2)  )
+      ALLOCATE( zt3ns(jpi,nn_hls,ipk,ipl,ipf,2), zt3sn(jpi,nn_hls,ipk,ipl,ipf,2),   &
+         &      zt3ew(jpj,nn_hls,ipk,ipl,ipf,2), zt3we(jpj,nn_hls,ipk,ipl,ipf,2)  )
       !
       ll_Iperio = nbondi == 2 .AND. (nperio == 1 .OR. nperio == 4 .OR. nperio == 6)
@@ -116,6 +116,6 @@
                ARRAY_IN(jpi,:,:,:,jf) = ARRAY_IN(  2  ,:,:,:,jf)
             ELSE                                   !* closed
-               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(     1       :jpreci,:,:,:,jf) = zland    ! east except F-point
-                                               ARRAY_IN(nlci-jpreci+1:jpi   ,:,:,:,jf) = zland    ! west
+               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(     1       :nn_hls,:,:,:,jf) = zland    ! east except F-point
+                                               ARRAY_IN(nlci-nn_hls+1:jpi   ,:,:,:,jf) = zland    ! west
             ENDIF
             !                                ! North-South boundaries
@@ -124,6 +124,6 @@
                ARRAY_IN(:,jpj,:,:,jf) = ARRAY_IN(:,   2  ,:,:,jf)
             ELSE                                   !* closed
-               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(:,     1       :jprecj,:,:,jf) = zland    ! south except F-point
-                                               ARRAY_IN(:,nlcj-jprecj+1:jpj   ,:,:,jf) = zland    ! north
+               IF( .NOT. NAT_IN(jf) == 'F' )   ARRAY_IN(:,     1       :nn_hls,:,:,jf) = zland    ! south except F-point
+                                               ARRAY_IN(:,nlcj-nn_hls+1:jpj   ,:,:,jf) = zland    ! north
             ENDIF
          END DO
@@ -142,6 +142,6 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
-                     zt3ew(:,jh,jk,jl,jf,1) = ARRAY_IN(jpreci+jh,:,jk,jl,jf)
+                  DO jh = 1, nn_hls
+                     zt3ew(:,jh,jk,jl,jf,1) = ARRAY_IN(nn_hls+jh,:,jk,jl,jf)
                      zt3we(:,jh,jk,jl,jf,1) = ARRAY_IN(iihom +jh,:,jk,jl,jf)
                   END DO
@@ -152,5 +152,5 @@
       !
       !                           ! Migrations
-      imigr = jpreci * jpj * ipk * ipl * ipf
+      imigr = nn_hls * jpj * ipk * ipl * ipf
       !
       SELECT CASE ( nbondi )
@@ -173,5 +173,5 @@
       !
       !                           ! Write Dirichlet lateral conditions
-      iihom = nlci-jpreci
+      iihom = nlci-nn_hls
       !
       SELECT CASE ( nbondi )
@@ -180,5 +180,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(iihom+jh,:,jk,jl,jf) = zt3ew(:,jh,jk,jl,jf,2)
                   END DO
@@ -190,5 +190,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(jh      ,:,jk,jl,jf) = zt3we(:,jh,jk,jl,jf,2)
                      ARRAY_IN(iihom+jh,:,jk,jl,jf) = zt3ew(:,jh,jk,jl,jf,2)
@@ -201,5 +201,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jpreci
+                  DO jh = 1, nn_hls
                      ARRAY_IN(jh      ,:,jk,jl,jf) = zt3we(:,jh,jk,jl,jf,2)
                   END DO
@@ -218,7 +218,7 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      zt3sn(:,jh,jk,jl,jf,1) = ARRAY_IN(:,ijhom +jh,jk,jl,jf)
-                     zt3ns(:,jh,jk,jl,jf,1) = ARRAY_IN(:,jprecj+jh,jk,jl,jf)
+                     zt3ns(:,jh,jk,jl,jf,1) = ARRAY_IN(:,nn_hls+jh,jk,jl,jf)
                   END DO
                END DO
@@ -228,5 +228,5 @@
       !
       !                           ! Migrations
-      imigr = jprecj * jpi * ipk * ipl * ipf
+      imigr = nn_hls * jpi * ipk * ipl * ipf
       !
       SELECT CASE ( nbondj )
@@ -249,5 +249,5 @@
       !
       !                           ! Write Dirichlet lateral conditions
-      ijhom = nlcj-jprecj
+      ijhom = nlcj-nn_hls
       !
       SELECT CASE ( nbondj )
@@ -256,5 +256,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,ijhom+jh,jk,jl,jf) = zt3ns(:,jh,jk,jl,jf,2)
                   END DO
@@ -266,5 +266,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,      jh,jk,jl,jf) = zt3sn(:,jh,jk,jl,jf,2)
                      ARRAY_IN(:,ijhom+jh,jk,jl,jf) = zt3ns(:,jh,jk,jl,jf,2)
@@ -277,5 +277,5 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jh = 1, jprecj
+                  DO jh = 1, nn_hls
                      ARRAY_IN(:,jh,jk,jl,jf) = zt3sn(:,jh,jk,jl,jf,2)
                   END DO
Index: /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_nfd_generic.h90
===================================================================
--- /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_nfd_generic.h90	(revision 9011)
+++ /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mpp_nfd_generic.h90	(revision 9012)
@@ -73,5 +73,5 @@
       ipj   = 4            ! 2nd dimension of message transfers (last j-lines)
       !
-      ALLOCATE( znorthloc(jpi,4,ipk,ipl,ipf) )
+      ALLOCATE( znorthloc(jpimax,4,ipk,ipl,ipf) )
       !
       znorthloc(:,:,:,:,:) = 0._wp
@@ -82,5 +82,5 @@
                DO jj = nlcj - ipj +1, nlcj
                   ij = jj - nlcj + ipj
-                  znorthloc(:,ij,jk,jl,jf) = ARRAY_IN(:,jj,jk,jl,jf)
+                  znorthloc(1:jpi,ij,jk,jl,jf) = ARRAY_IN(1:jpi,jj,jk,jl,jf)
                END DO
             END DO
@@ -89,5 +89,5 @@
       !
       !
-      itaille = jpi * ipj * ipk * ipl * ipf
+      itaille = jpimax * ipj * ipk * ipl * ipf
       !
       IF( l_north_nogather ) THEN      !==  ????  ==!
@@ -177,5 +177,5 @@
       ELSE                             !==  ????  ==!
          ALLOCATE( ztab       (jpiglo,4,ipk,ipl,ipf     ) )
-         ALLOCATE( znorthgloio(jpi   ,4,ipk,ipl,ipf,jpni) )
+         ALLOCATE( znorthgloio(jpimax,4,ipk,ipl,ipf,jpni) )
          !
          CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
@@ -222,11 +222,4 @@
       ENDIF
       !
-      ! The ztab array has been either:
-      !  a. Fully populated by the mpi_allgather operation or
-      !  b. Had the active points for this domain and northern neighbours populated
-      !     by peer to peer exchanges
-      ! Either way the array may be folded by lbc_nfd and the result for the span of
-      ! this domain will be identical.
-      !
       DEALLOCATE( znorthloc )
       !
Index: /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90
===================================================================
--- /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 9011)
+++ /branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 9012)
@@ -1,18 +1,27 @@
 MODULE mppini
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE mppini   ***
    !! Ocean initialization : distributed memory computing initialization
-   !!==============================================================================
-
-   !!----------------------------------------------------------------------
-   !!   mpp_init       : Lay out the global domain over processors
-   !!   mpp_init2      : Lay out the global domain over processors 
-   !!                    with land processor elimination
-   !!   mpp_init_ioispl: IOIPSL initialization in mpp
-   !!----------------------------------------------------------------------
-   USE dom_oce         ! ocean space and time domain 
-   USE in_out_manager  ! I/O Manager
-   USE lib_mpp         ! distribued memory computing library
-   USE ioipsl
+   !!======================================================================
+   !! History :  6.0  !  1994-11  (M. Guyon)  Original code
+   !!  OPA       7.0  !  1995-04  (J. Escobar, M. Imbard)
+   !!            8.0  !  1998-05  (M. Imbard, J. Escobar, L. Colombet )  SHMEM and MPI versions
+   !!  NEMO      1.0  !  2004-01  (G. Madec, J.M Molines)  F90 : free form , north fold jpni > 1
+   !!            4.0  !  2016-06  (G. Madec)  use domain configuration file instead of bathymetry file
+   !!            4.0  !  2017-06  (J.M. Molines, T. Lovato) merge of mppini and mppini_2
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!  mpp_init       : Lay out the global domain over processors with/without land processor elimination
+   !!  mpp_init_mask  : 
+   !!  mpp_init_ioipsl: IOIPSL initialization in mpp 
+   !!----------------------------------------------------------------------
+   USE dom_oce        ! ocean space and time domain
+   USE bdy_oce        ! open BounDarY  
+   !
+   USE lib_mpp        ! distribued memory computing library
+   USE iom            ! nemo I/O library 
+   USE ioipsl         ! I/O IPSL library
+   USE in_out_manager ! I/O Manager
 
    IMPLICIT NONE
@@ -20,8 +29,7 @@
 
    PUBLIC mpp_init       ! called by opa.F90
-   PUBLIC mpp_init2      ! called by opa.F90
-
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -41,12 +49,8 @@
       !!
       !! ** Method  :   Shared memory computing, set the local processor
-      !!      variables to the value of the global domain
-      !!
-      !! History :
-      !!   9.0  !  04-01  (G. Madec, J.M. Molines)  F90 : free form, north fold jpni >1
-      !!----------------------------------------------------------------------
-
-      ! No mpp computation
-      nimpp  = 1
+      !!              variables to the value of the global domain
+      !!----------------------------------------------------------------------
+      !
+      nimpp  = 1           ! 
       njmpp  = 1
       nlci   = jpi
@@ -61,31 +65,25 @@
       nidom  = FLIO_DOM_NONE
       npolj = jperio
-
+      !
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'mpp_init(2) : NO massively parallel processing'
-         WRITE(numout,*) '~~~~~~~~~~~ '
-         WRITE(numout,*) '         nperio = ', nperio
-         WRITE(numout,*) '         npolj  = ', npolj
-         WRITE(numout,*) '         nimpp  = ', nimpp
-         WRITE(numout,*) '         njmpp  = ', njmpp
-      ENDIF
-
-      IF(  jpni /= 1 .OR. jpnj /= 1 .OR. jpnij /= 1 ) &
-          CALL ctl_stop( 'equality  jpni = jpnj = jpnij = 1 is not satisfied',   &
-          &              'the domain is lay out for distributed memory computing! ' )
-
-      IF( jperio == 7 ) CALL ctl_stop( ' jperio = 7 needs distributed memory computing ',   &
-          &              ' with 1 process. Add key_mpp_mpi in the list of active cpp keys ' )
+         WRITE(numout,*) 'mpp_init : NO massively parallel processing'
+         WRITE(numout,*) '~~~~~~~~ '
+         WRITE(numout,*) '   nperio = ', nperio, '   nimpp  = ', nimpp
+         WRITE(numout,*) '   npolj  = ', npolj , '   njmpp  = ', njmpp
+      ENDIF
+      !
+      IF(  jpni /= 1 .OR. jpnj /= 1 .OR. jpnij /= 1 )                                     &
+         CALL ctl_stop( 'mpp_init: equality  jpni = jpnj = jpnij = 1 is not satisfied',   &
+            &           'the domain is lay out for distributed memory computing!' )
+         !
+      IF( jperio == 7 ) CALL ctl_stop( 'mpp_init: jperio = 7 needs distributed memory computing ',       &
+         &                             'with 1 process. Add key_mpp_mpi in the list of active cpp keys ' )
+         !
    END SUBROUTINE mpp_init
 
-
-   SUBROUTINE mpp_init2 
-      CALL mpp_init                             ! same routine as mpp_init
-   END SUBROUTINE mpp_init2
-
 #else
    !!----------------------------------------------------------------------
-   !!   'key_mpp_mpi'          OR         MPI massively parallel processing
+   !!   'key_mpp_mpi'                     MPI massively parallel processing
    !!----------------------------------------------------------------------
 
@@ -95,4 +93,8 @@
       !!                    
       !! ** Purpose :   Lay out the global domain over processors.
+      !!      If land processors are to be eliminated, this program requires the
+      !!      presence of the domain configuration file. Land processors elimination
+      !!      is performed if jpni x jpnj /= jpnij. In this case, using the MPP_PREP
+      !!      preprocessing tool, help for defining the best cutting out.
       !!
       !! ** Method  :   Global domain is distributed in smaller local domains.
@@ -103,5 +105,5 @@
       !!                     nperio local  periodic condition
       !!
-      !! ** Action  : - set domain parameters
+      !! ** Action : - set domain parameters
       !!                    nimpp     : longitudinal index 
       !!                    njmpp     : latitudinal  index
